--Original by xXxMoNkEyMaNxXx
local sin, cos, atan2, sqrt, pi = math.sin, math.cos, math.atan2, math.sqrt, math.pi
local gr, tm = love.graphics, love.timer
--localize
local down	= love.mouse.isDown
local pos	= love.mouse.getPosition
local time	= love.timer.getTime
--vars
local dragging
local offset

--Textured Polygon Demo--

function love.load()
	image = gr.newImage( 'lenaC.jpg' )
	width,height = gr.getWidth(), gr.getHeight()
	gr.setBackgroundColor( 55, 55, 255, 255 )
	gr.setCaption( 'Quad Texturing Effect Test' )
	vertices={{100,100},{200,100},{200,200.001},{100.001,200}}
	fig = {
		sides	= 4,
		angle	= 0,
		size	= 400,
		center	= { x = width / 2, y = height / 2 }
		}
	load_effect()
	end

function love.draw()

	update_effect( image, vertices[1], vertices[4], vertices[3], vertices[2] )
	gr.setPixelEffect( glsl )
	gr.quad('fill',vertices[1][1],vertices[1][2],vertices[2][1],vertices[2][2],vertices[3][1],vertices[3][2],vertices[4][1],vertices[4][2],vertices[1][1],vertices[1][1])
	gr.setPixelEffect()

	update_effect( image, po[1], po[2], po[3], po[4] )
	gr.setPixelEffect( glsl )
	gr.polygon('fill',po[1][1],po[1][2],po[2][1],po[2][2],po[3][1],po[3][2],po[4][1],po[4][2])
	gr.setPixelEffect()

	gr.setColor(255,255,0,255)
	gr.print( 'fps: '..tm.getFPS( ), width-100, height-20 )

	end

function love.keypressed( key )
	if key == "escape" then love.event.quit() end
	end

function love.update(dt)
	fig.angle	= fig.angle + dt / 2
	po			= create_quad( fig )
	po[1][1]	= po[1][1] + .001	-- make sure opposite faces aren't parallel
	po[3][2]	= po[3][2] + .001
	local x,y	= pos()
	local b1d	= down('l')
	if dragging then
		vertices[dragging] = { x + offset[1], y + offset[2] }
		if not b1d then
			dragging = nil
		end
		elseif b1d then
			local vc
			local best = math.huge
			for i,v in next,vertices do
				local dis = math.sqrt((v[1]-x)^2+(v[2]-y)^2)
				if dis < best then
					vc, best = i, dis
				end
			end
			dragging,offset = vc, {vertices[vc][1]-x,vertices[vc][2]-y}
		end
	end
-----------------------------------------------------------
function create_quad( obj )	-- creates a quad
		local angle_step	= 90
		local poly			= {}
		for side			= 1, 4 do
			poly[side]		= {}
			poly[side][1]	= (obj.size*sin((angle_step*(side-1)+obj.angle) * pi / 180+obj.angle) / 2+obj.center.x)
			poly[side][2]	= (obj.size*cos((angle_step*(side-1)+obj.angle) * pi / 180+obj.angle) / 2+obj.center.y)
			end
		return poly
		end
------------------------------------------------------------
function load_effect()
	glsl = gr.newPixelEffect[[
// Made by xXxMoNkEyMaNxXx

extern Image img;
extern vec2 v1;
extern vec2 v2;
extern vec2 v3;
extern vec2 v4;

extern number SIZEY; //So annoying

number c(vec2 v1,vec2 v2)
	{
	return v1.x*v2.y-v2.x*v1.y;
	}
number intersect(vec2 v1,vec2 d1,vec2 v2,vec2 d2)
	{
	return c(v2-v1,d2)/c(d1,d2);
	}
vec4 mask(vec4 base,vec4 over)
	{
	return vec4(over.rgb*over.a+base.rgb*(1-over.a),over.a+base.a*(1-over.a));
	}
vec4 effect(vec4 colour,Image UNUSED1,vec2 UNUSED2,vec2 inverted)
{
	vec2 p = vec2( inverted.x, SIZEY-inverted.y ); //SO ANNOYING

	vec2 A1 = normalize( v2 - v1 );
	vec2 A2 = normalize( v3 - v4 );

	vec2 B1 = normalize( v2 - v3 );
	vec2 B2 = normalize( v1 - v4 );

	//Vanishing points
	vec2 A = v1 + A1 * intersect( v1, A1, v4, A2 );
	vec2 B = v3 + B1 * intersect( v3, B1, v4, B2 );

	//Horizon
	vec2 H = normalize(A-B);

	//Unit
	vec2 ab = vec2( intersect(v4,-H,v2,-A1), intersect(v4,H,v2,-B1) );

	//Pixel
	vec2 uv = vec2( intersect(v4,-H,A,normalize(p-A)), intersect(v4,H,B,normalize(p-B)) );

	return mask( colour, Texel( img, uv / ab ) );
}
]]
	end
--------------------------------------------------------------
function update_effect(img,v1,v2,v3,v4)
	glsl.send (glsl,"SIZEY",gr.getHeight())--So annoying
	glsl.send (glsl,"img",img)
	glsl.send (glsl,"v1",v1)
	glsl.send (glsl,"v2",v2)
	glsl.send (glsl,"v3",v3)
	glsl.send (glsl,"v4",v4)
	end
---------------------------------------------------------------
